-- This script transforms events from the "Encuesta Nacional de Hospitales" Google form, which is published
-- to PubSub as a JSON with answers to all the questions in the form.
--
-- An example payload can be found at eh_payload_example.json
SELECT DISTINCT
  JSON_EXTRACT_SCALAR(payload, '$.0') AS timestamp,
  JSON_EXTRACT_SCALAR(payload, '$.1') AS report_week,
  JSON_EXTRACT_SCALAR(payload, '$.10') AS operability_icu,
  JSON_EXTRACT_SCALAR(payload, '$.100') AS power_outage_equipment_failure_specify,
  JSON_EXTRACT_SCALAR(payload, '$.101') AS power_generator_available,
  JSON_EXTRACT_SCALAR(payload, '$.102') AS power_outage_mortatility,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.103') AS int64) AS power_outage_deaths_count,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.104') AS int64) AS mortality_hospital_failure_cardiovascular_count,
  JSON_EXTRACT_SCALAR(payload, '$.105') AS mortality_hospital_failure_cardiovascular_cause,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.106') AS int64) AS mortality_hospital_failure_trauma_count,
  JSON_EXTRACT_SCALAR(payload, '$.107') AS mortality_hospital_failure_trauma_cause,
  JSON_EXTRACT_SCALAR(payload, '$.108') AS strike_medical_staff_affected,
  JSON_EXTRACT_SCALAR(payload, '$.109') AS strike_nurses_affected,
  JSON_EXTRACT_SCALAR(payload, '$.11') AS operability_icu_p,
  JSON_EXTRACT_SCALAR(payload, '$.110') AS strike_other_staff_affected,
  JSON_EXTRACT_SCALAR(payload, '$.111') AS strike_patients_affected,
  JSON_EXTRACT_SCALAR(payload, '$.112') AS strike_other_affected,
  JSON_EXTRACT_SCALAR(payload, '$.113') AS staff_violence_affected_reasons,
  JSON_EXTRACT_SCALAR(payload, '$.114') AS epidemiological_emergency_suspected_diseases,
  JSON_EXTRACT_SCALAR(payload, '$.115') AS rrt_avail_high_flow_catheters,
  JSON_EXTRACT_SCALAR(payload, '$.116') AS rrt_avail_blood_tests_hiv_hvb_hvc_vdr,
  JSON_EXTRACT_SCALAR(payload, '$.117') AS rrt_avail_immediate_access_urea_reduction_bun,
  JSON_EXTRACT_SCALAR(payload, '$.118') AS nCoV_face_mask_avail,
  JSON_EXTRACT_SCALAR(payload, '$.119') AS nCoV_respiratory_isolation_protocol_avail,
  JSON_EXTRACT_SCALAR(payload, '$.12') AS operability_er,
  JSON_EXTRACT_SCALAR(payload, '$.120') AS nCoV_isolation_area_avail,
  JSON_EXTRACT_SCALAR(payload, '$.13') AS operability_sx,
  JSON_EXTRACT_SCALAR(payload, '$.14') AS operability_lab,
  JSON_EXTRACT_SCALAR(payload, '$.15') AS operability_uls,
  JSON_EXTRACT_SCALAR(payload, '$.16') AS operability_ct_mri,
  JSON_EXTRACT_SCALAR(payload, '$.17') AS operability_xr,
  JSON_EXTRACT_SCALAR(payload, '$.18') AS er_avail_adrenalin,
  JSON_EXTRACT_SCALAR(payload, '$.19') AS er_avail_atropine,
  JSON_EXTRACT_SCALAR(payload, '$.2') AS hospital_code,
  JSON_EXTRACT_SCALAR(payload, '$.20') AS er_avail_dopamine,
  JSON_EXTRACT_SCALAR(payload, '$.21') AS er_avail_cephalosporins_betalactams,
  JSON_EXTRACT_SCALAR(payload, '$.22') AS er_avail_aminoglycosides_quinolone,
  JSON_EXTRACT_SCALAR(payload, '$.23') AS er_avail_vancomycin_clindamycin,
  JSON_EXTRACT_SCALAR(payload, '$.24') AS er_avail_lidocaine,
  JSON_EXTRACT_SCALAR(payload, '$.25') AS er_avail_minor_opioids,
  JSON_EXTRACT_SCALAR(payload, '$.26') AS er_avail_major_opioids,
  JSON_EXTRACT_SCALAR(payload, '$.27') AS er_avail_iv_fluids,
  JSON_EXTRACT_SCALAR(payload, '$.28') AS er_avail_diazepam_dph,
  JSON_EXTRACT_SCALAR(payload, '$.29') AS er_avail_heparin,
  JSON_EXTRACT_SCALAR(payload, '$.3') AS federal_entity,
  JSON_EXTRACT_SCALAR(payload, '$.30') AS er_avail_steroids,
  JSON_EXTRACT_SCALAR(payload, '$.31') AS er_avail_insulin,
  JSON_EXTRACT_SCALAR(payload, '$.32') AS er_avail_asthma,
  JSON_EXTRACT_SCALAR(payload, '$.33') AS er_avail_blood_pressure,
  JSON_EXTRACT_SCALAR(payload, '$.34') AS er_avail_defibrillator,
  JSON_EXTRACT_SCALAR(payload, '$.35') AS er_avail_ott_intubation,
  JSON_EXTRACT_SCALAR(payload, '$.36') AS er_avail_catheter,
  JSON_EXTRACT_SCALAR(payload, '$.37') AS er_avail_oxygen_suction,
  JSON_EXTRACT_SCALAR(payload, '$.38') AS sx_avail_minor_opioids,
  JSON_EXTRACT_SCALAR(payload, '$.39') AS sx_avail_major_opioids,
  JSON_EXTRACT_SCALAR(payload, '$.4') AS hospital_type,
  JSON_EXTRACT_SCALAR(payload, '$.40') AS sx_avail_anesthetic_gases,
  JSON_EXTRACT_SCALAR(payload, '$.41') AS sx_avail_anesthetics_iv,
  JSON_EXTRACT_SCALAR(payload, '$.42') AS sx_avail_relaxants,
  JSON_EXTRACT_SCALAR(payload, '$.43') AS sx_avail_ott_intubation,
  JSON_EXTRACT_SCALAR(payload, '$.44') AS sx_avail_patient_lingerie_kit,
  JSON_EXTRACT_SCALAR(payload, '$.45') AS sx_avail_disposables_mask_gloves_gown,
  JSON_EXTRACT_SCALAR(payload, '$.46') AS sx_avail_oxygen_suction,
  JSON_EXTRACT_SCALAR(payload, '$.47') AS rrt_avail,
  JSON_EXTRACT_SCALAR(payload, '$.48') AS rrt_operability,
  JSON_EXTRACT_SCALAR(payload, '$.49') AS rrt_date_stopped_operability,
  JSON_EXTRACT_SCALAR(payload, '$.5') AS administrative_entity,
  JSON_EXTRACT_SCALAR(payload, '$.50') AS rrt_reason_stopped_operability,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.51') AS int64) AS rrt_avg_daily_patients,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.52') AS int64) AS rrt_peritoneal_count,
  JSON_EXTRACT_SCALAR(payload, '$.53') AS rrt_peritoneal_reason_not_performed,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.54') AS int64) AS rrt_num_hemodialysis,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.55') AS int64) AS rrt_num_hemodialysis_acute,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.56') AS int64) AS rrt_num_hemodialysis_chronic,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.57') AS int64) AS rrt_num_hemodialysis_equipments,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.58') AS int64) AS rrt_num_hemodialysis_equipments_operability,
  JSON_EXTRACT_SCALAR(payload, '$.59') AS rrt_hemodialysis_avail_filter,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.6') AS int64) AS arch_beds_count,
  JSON_EXTRACT_SCALAR(payload, '$.60') AS rrt_hemodialysis_avail_lines,
  JSON_EXTRACT_SCALAR(payload, '$.61') AS rrt_hemodialysis_avail_kit_hemodialysis,
  JSON_EXTRACT_SCALAR(payload, '$.62') AS rrt_hemodialysis_avail_iron,
  JSON_EXTRACT_SCALAR(payload, '$.63') AS rrt_hemodialysis_avail_b_complex,
  JSON_EXTRACT_SCALAR(payload, '$.64') AS rrt_hemodialysis_avail_calcium,
  JSON_EXTRACT_SCALAR(payload, '$.65') AS rrt_hemodialysis_avail_zemblar,
  JSON_EXTRACT_SCALAR(payload, '$.66') AS rrt_reverse_osmosis_unit_operability,
  JSON_EXTRACT_SCALAR(payload, '$.67') AS rrt_staff_nephrology,
  JSON_EXTRACT_SCALAR(payload, '$.68') AS rrt_staff_md,
  JSON_EXTRACT_SCALAR(payload, '$.69') AS rrt_staff_resident,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.7') AS int64) AS op_beds_count,
  JSON_EXTRACT_SCALAR(payload, '$.70') AS rrt_staff_nurse,
  JSON_EXTRACT_SCALAR(payload, '$.71') AS rrt_staff_nurse_nephrologist,
  JSON_EXTRACT_SCALAR(payload, '$.72') AS nutr_avail,
  JSON_EXTRACT_SCALAR(payload, '$.73') AS nutr_operability,
  JSON_EXTRACT_SCALAR(payload, '$.74') AS nutr_date_stopped_operability,
  JSON_EXTRACT_SCALAR(payload, '$.75') AS nutr_reason_stopped_operability,
  JSON_EXTRACT_SCALAR(payload, '$.76') AS nutr_num,
  JSON_EXTRACT_SCALAR(payload, '$.77') AS nutr_daily_freq_meal,
  JSON_EXTRACT_SCALAR(payload, '$.78') AS nutr_quality,
  JSON_EXTRACT_SCALAR(payload, '$.79') AS nutr_freq_milk_formulas,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.8') AS int64) AS op_beds_er_count,
  TIMESTAMP_DIFF(PARSE_TIMESTAMP('%Y-%m-%dT%H:%M:%E*SZ', JSON_EXTRACT_SCALAR(payload, '$.80')), PARSE_TIMESTAMP('%Y-%m-%dT%H:%M:%E*SZ', '1899-12-30T00:00:00.000Z'), MINUTE) AS pneumonia_antibiotic_therapy_latency,
  TIMESTAMP_DIFF(PARSE_TIMESTAMP('%Y-%m-%dT%H:%M:%E*SZ', JSON_EXTRACT_SCALAR(payload, '$.81')), PARSE_TIMESTAMP('%Y-%m-%dT%H:%M:%E*SZ', '1899-12-30T00:00:00.000Z'), MINUTE) AS mi_thrombolytic_treatment_latency,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.82') AS int64) AS er_staff_residents_and_rural_day_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.83') AS int64) AS er_staff_specialist_day_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.84') AS int64) AS er_staff_mic_day_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.85') AS int64) AS er_staff_nurse_day_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.86') AS int64) AS er_staff_non_professional_nurse_day_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.87') AS int64) AS er_staff_residents_and_rural_night_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.88') AS int64) AS er_staff_specialist_night_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.89') AS int64) AS er_staff_mic_night_on_call,
  JSON_EXTRACT_SCALAR(payload, '$.9') AS op_pavilions_count,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.90') AS int64) AS er_staff_nurse_night_on_call,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.91') AS int64) AS er_staff_non_professional_nurse_night_on_call,
  JSON_EXTRACT_SCALAR(payload, '$.92') AS wash_failure_icu,
  JSON_EXTRACT_SCALAR(payload, '$.93') AS wash_failure_er,
  JSON_EXTRACT_SCALAR(payload, '$.94') AS wahs_failure_sx,
  JSON_EXTRACT_SCALAR(payload, '$.95') AS power_outage,
  SAFE_CAST(JSON_EXTRACT_SCALAR(payload, '$.96') AS int64) AS power_outage_avg_failures_per_day,
  JSON_EXTRACT_SCALAR(payload, '$.97') AS power_outage_days_count,
  JSON_EXTRACT_SCALAR(payload, '$.98') AS power_outage_avg_duration,
  JSON_EXTRACT_SCALAR(payload, '$.99') AS power_outage_equipment_failure
FROM `{{ params.raw_events_table }}`
WHERE event = 'eh_health_survey_response'
